unit mNebenlauf;

interface

uses classes;

type Nebenlauf=class(tThread)
  constructor init;  virtual;
  procedure start; virtual;
  procedure stopp; virtual;
  destructor gibFrei; virtual;
  procedure execute; override;
  procedure aktion; virtual; abstract;
  function  beendet: boolean;
end;

implementation

 constructor Nebenlauf.init;
 begin
   self.create(true);
 end;

 procedure Nebenlauf.start;
 begin
   self.resume;
 end;

 procedure Nebenlauf.stopp;
 begin
   self.terminate;
 end;

 destructor Nebenlauf.gibFrei;
 begin
   self.destroy;
 end;

 procedure Nebenlauf.execute;
 begin
   self.aktion;
 end;

 function Nebenlauf.beendet: boolean;
 begin
   result := terminated
 end;

end.

